#!/usr/bin/perl
my $var;


#poner package sudo
#REPPACK
my $DISTRO=$ARGV[0];

my $PACKS="/tmp/packs";
mkdir $PACKS;
print "REPPACK $DISTRO \n";
use Data::Dumper;

#               'REDHAT-RPM'   =>['svn2cl'           ,'gral'],

#el pack o sea primer argumento del array no sirve para nada 
#si el segundo no es gral

my $paquetes={
   'detecta' =>{'ALL'          =>['detecta'          ,'detecta']},
   'rpm'     =>{'REDHAT-RPM'   =>['rpm'              ,'rpm'],
                'GENTOO-EBUILD'=>['rpm'              ,'rpm']},
   'latex2html'
             =>{'DEBIAN-DEB   '=>['latex2html'       ,'latex2html'],
                'GENTOO-EBUILD'=>['latex2html'       ,'latex2html']},
   'xz'      =>{'GENTOO-EBUILD'=>['xz'               ,'xz']},
   'muse-el' =>{'GENTOO-EBUILD'=>['app-emacs/muse'   ,'gral'],
                'SUSE-RPM'     =>['muse-el'          ,'muse-el'],
                'DEBIAN-DEB   '=>['app-emacs/muse'   ,'gral'],
                'REDHAT-RPM'   =>[' emacs-muse'      ,'gral']},
   'latex'   =>{'GENTOO-EBUILD'=>['latex'            ,'latex']},
   'svn2cl'  =>{'GENTOO-EBUILD'=>['dev-util/svn2cl'  ,'gral'],
                'SUSE-RPM'     =>['svn2cl'           ,'svn2cl'],
                'DEBIAN-DEB'   =>['subversion-tools' ,'gral'],
                'REDHAT-RPM'   =>['subversion-svn2cl','gral']},
   'dpkg'    =>{'SUSE-RPM'     =>['dpkg'             ,'dpkg'],
                'GENTOO-EBUILD'=>['app-arch/dpkg'    ,'gral']},
   'tgif'    =>{'SUSE-RPM'     =>['tgif'             ,'tgif'],
                'GENTOO-EBUILD'=>['tgif'             ,'tgif']}
};

#multiples opciones para cada nombre generico
#multiples paquetes en cada opcion

#suse
#cc      gcc
#latex   texlive texlive-latex
#fortran gcc-fortran

#debian
#cc      gcc
#fortran gfortran

#gentoo
#emacs   virtual/emacs 

#redhat
#svn2cl  subversion-svn2cl
#fortran gcc-gfortran
#latex   texlive-latex

# como es makeinfo
#httpd   es apache
# accion-distro

################################3 #ALL

$funcion{'detecta-ALL'}=sub {
 #   system("cp contrib/detectahttpd /usr/bin");
                     #== 0  or die "System fail: $?\n";
 #   system("cp contrib/infosis /usr/bin");
                     #== 0  or die "System fail: $?\n";
};

############################## GRAL

$funcion{'gral-SUSE-RPM'}=sub {
       print "zypper install @_\n";
       system("zypper install @_");
       #autoconf automake gcc make texlive wget lsb-release svn2cl\
       #texlive-latex latex2html emacs gcc-fortran xz makeinfo 
};

$funcion{'gral-DEBIAN-DEB'}=sub {
       print "apt-get install @_\n";
       system("apt-get install @_");
#DEBIAN
#      system("apt-get install subversion lsb-release autoconf 
#         automake gcc gfortran\
#          texlive-latex-base tgif  emacs sudo rpm texinfo");

};
$funcion{'gral-GENTOO-DEB'}=sub {
       print "emerge @_\n";
       system("emerge @_");
#GENTOO
#system("emerge subversion sudo lsb-release wget 
#		virtual/emacs app-emacs/muse dev-util/svn2cl app-arch/dpkg");
};

$funcion{'gral-REDHAT-RPM'}=sub {
       print "yum -y install @_\n";
       system("yum -y install @_");
#REDHAT
#  system("yum -y install subversion subversion-svn2cl autoconf automake \
#   make gcc redhat-lsb gcc-gfortran wget\
#	 texinfo texlive-latex tgif emacs-muse httpd emacs latex2html xz");
#     system("rpmdev-setuptree")
};


#ojo con _ por - entre nombre de paquete y directorio debian
# el "gral" baja 112M

########### ordenar por paquete
################### SUSE

# sudo esta demas pues esto va sobre sudo
$funcion{'svn2cl-SUSE-RPM'}=sub {
   my $DIR="svn2cl-0.12";
   system("wget -P$PACKS -c http://arthurdejong.org/svn2cl/$DIR.tar.gz");
   system("sudo tar -zxvf $PACKS/$DIR.tar.gz -C /opt");
   system("sudo ln -s /opt/$DIR/svn2cl.sh /usr/local/bin");
   
};


$funcion{'muse-el-SUSE-RPM'}=sub {
   my $DIR="muse-latest";
   system("wget -P$PACKS -c http://mwolson.org/static/dist/$DIR.tar.gz");
   system("tar -zxvf $PACKS/$DIR.tar.gz -C$PACKS");
   system("make -C $PACKS/$DIR");
   system("sudo make install -C $PACKS/$DIR");
};

$funcion{'dpkg-SUSE-RPM'}=sub {
   my $DIR="dpkg_1.15.5.5";
   system("wget -P$PACKS-c http://ftp.de.debian.org/debian/pool/main/d/dpkg/$DIR.tar.bz2");
   system("tar -jxvf $PACKS/$DIR.tar.bz2 -C$PACKS");
   system("make -C $PACKS/$DIR");
   system("sudo make install -C $PACKS/$DIR");
};

$funcion{'tgif-SUSE-RPM'}=sub {
    system("zypper ar http://download.opensuse.org/repositories/openSUSE:/11.2:/Contrib/standard Contrib");
             # == 0  or die "System fail: $?\n";
   system("zypper install tgif");#== 0  or die "System fail: $?\n";
};

###########################3 REDHAT

$funcion{'rpm-REDHAT-RPM'}=sub {
    system("yum -y install rpm rpm-build rpmdevtools");
    system("rpmdev-setuptree");
    #rpm siempre esta, pero ... asi actualiza
};


##########################3 GENTOO

$funcion{'tgif-GENTOO-EBUILD'}=sub {
    system("emerge /usr/portage/media-gfx/tgif/tgif-4.1.45-r1.ebuild");#== 0  or die "System fail: $?\n";
};

$funcion{'latex2html-GENTOO-EBUILD'}=sub {
    system("emerge USE=\"kpathsea png gif\" latex2html");
};

$funcion{'latex-GENTOO-EBUILD'}=sub {
    system("emerge USE=\"kpathsea\" texlive");
    system("emerge USE=\"kpathsea\" --nodeps latex-unicode");
};

$funcion{'xz-GENTOO-EBUILD'}=sub {
   system("emerge /usr/portage/app-arch/tar/tar-1.22.ebuild");
   system("emerge /usr/portage/app-arch/xz-utils/xz-utils-9999.ebuild");
};

$funcion{'rpm-GENTOO-EBUILD'}=sub {
#"rpm ultimo sin falla por magic"; 
    system("emerge /usr/portage/app-arch/rpm/rpm-5.1.6.ebuild");
};

################################3 DEBIAN

$funcion{'latex2html-DEBIAN-DEB'}=sub {
  #cat /etc/apt/sources.list| grep non-free>haynonfree
  #if ! test -s haynonfree; then
     system("echo deb http://http.us.debian.org/debian sid non-free >>/etc/apt/sources.list");
     system("apt-get update");
  #fi
  #esto se podria hacer en general y tener dos pasos, el previo y el general
  system("apt-get install latex2html");
}; 

##########################################3

open LACKS, "lacks" or die "NO HAY ARCHIVO lacks\n";;
while (<LACKS>){
    chomp;
    $var=$_;
}
close LACKS;

@faltan=split(/:/,$var);

my %accionesdistro;
my %accionesall;

my $estaen;
foreach (@faltan){
    #print "PACK $_\n";
    my $pack   =$paquetes->{$_}->{$DISTRO}->[0];
    my $accion =$paquetes->{$_}->{$DISTRO}->[1];
    $estaen='';
    if ($pack){
       $estaen=$DISTRO;
       if (scalar @{$accionesdistro{$accion}} == 0){
         $accionesdistro{$accion}=[$pack];  
       }else{
         $accionesdistro{$accion}=[@$accionesdistro{$accion},$pack];  
       }
      }else{
       $pack   =$paquetes->{$_}->{'ALL'}->[0];
       $accion =$paquetes->{$_}->{'ALL'}->[1];
       if ($pack){
           $estaen='ALL';
           if (scalar @{$accionesall{$accion}} == 0){
             $accionesall{$accion}=[$pack];  
           }else{
             $accionesall{$accion}=[@{$accionesall{$accion}},$pack];  
           }
       }
    }
    if ($estaen){
      print "$_: $pack - $estaen -$accion\n";
    }else{
      print "$_: Package no registrado\n";
      $accionesdistro{'gral'}=[@{$accionesdistro{'gral'}},$_];  
    }
}

print "GENERAL\n";
foreach my $accion (keys %accionesall){
    print "$accion: (";
    foreach (@{$accionesall{$accion}}){
        print "$_,";     
    }
    print ")";
    if (exists $funcion{"$accion-ALL"}){
	print "Funcion $accion-ALL:\n";
            $funcion{"$accion-ALL"}(@{$accionesall{$accion}});
        }else{
	    print "Sin funcion";
        }
    print "\n";
}

print "DISTRO: $DISTRO\n";
foreach my $accion (keys %accionesdistro){
    print "$accion: (";
    foreach (@{$accionesdistro{$accion}}){
        print "$_,";
        }
     print ")";
     if (exists $funcion{"$accion-$DISTRO"}){
	 print "Funcion $accion-$DISTRO:\n";
          $funcion{"$accion-$DISTRO"}(@{$accionesdistro{$accion}});
         }else{
	    print "Sin funcion: $accion-$DISTRO";
    }
    print "\n";
}




# en Fedora "rpm" puede ser rpm y rpm-build, raro que rpm no este pero el
#  rpm-build no viene por defecto
#rpmdev-setuptree crea la estructura de directorios en el dir de usuario
# en este caso root
